<?php
/**
 * This is the object containing the ActiveFilters data for the selected filter
 * \ingroup configFilters
 * \defgroup updateActiveFilter updateActiveFilter
 * @{
 */
class ActiveFilters {
    private $activefilter, $parent;
    public function __construct($activefilterObj, $parentObj) {
        $this->activefilter = $activefilterObj;
        $this->parent = $parentObj;
    }
    public function __destruct() {
        //filters_d($this->getActiveFilterObj());
        
    }
    public function getSessionObj() {
        if ($this->parent == null) return $this->session;
        return $this->parent->getSessionObj();
    }
    public function getActiveFilterObj() {
        return $this->activefilter;
    }
    /**
     * This method must be called if one of the members has been changed
     * @return bool
     */
    public function save() {
        if (!$this) return false;
        $resp = filters_save($this->parent->getFiltersObj() , $this->getSessionObj());
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SAVEACTIVEFILTERDATA);
    }
    /**
Set member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>priority</td>
<td>the priority of the filter</td>
<tr><td>filterName</td>
<td>the name of the filter as defined in the socket/script object set</td>
<tr><td>filterType</td>
<td>type of the filter (to which the object set belongs)</td>
<tr><td>applyOn</td>
<td>Specifies where this filter is activated (local, relay delivery or both) (available only on server filters)</td>
<tr><td>fiteringOn</td>
<td>applies filter on levels: received|sent|sentAndReceived (available only on domain/accounts filters)</td>
</table>
     */
    public function __set($varName, $varValue) {
        if (!$this) return false;
        switch (strtolower($varName)) {
            case "priority":
                $resp = active_filter_priority_set($this->getActiveFilterObj() , $varValue);
            break;
            case "filtername":
                $resp = active_filter_filter_name_set($this->getActiveFilterObj() , $varValue);
            break;
            case "filtertype":
                $resp = active_filter_filter_type_set($this->getActiveFilterObj() , $varValue);
            break;
            case "applyon":
                $resp = active_filter_apply_on_set($this->getActiveFilterObj() , $varValue);
            break;
            case "filteringon":
                $resp = active_filter_filtering_on_set($this->getActiveFilterObj() , $varValue);
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::SETACTIVEFILTERVARERROR);
                return;
        }
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SETACTIVEFILTERVARERROR);
    }
    /**
Get member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>priority</td>
<td>the priority of the filter</td>
<tr><td>filterName</td>
<td>the name of the filter as defined in the socket/script object set</td>
<tr><td>filterType</td>
<td>type of the filter (to which the object set belongs)</td>
<tr><td>applyOn</td>
<td>Specifies where this filter is activated (local, relay delivery or both) (available only on server filters)</td>
<tr><td>fiteringOn</td>
<td>applies filter on levels: received|sent|sentAndReceived (available only on domain/accounts filters)</td>
</table>
     */
    public function __get($varName) {
        if (!$this) return false;
        switch (strtolower($varName)) {
            case "priority":
                return active_filter_priority_get($this->getActiveFilterObj());
            break;
            case "filtername":
                return active_filter_filter_name_get($this->getActiveFilterObj());
            break;
            case "filtertype":
                return active_filter_filter_type_get($this->getActiveFilterObj());
            break;
            case "applyon":
                return active_filter_apply_on_get($this->getActiveFilterObj());
            break;
            case "filteringon":
                return active_filter_filtering_on_get($this->getActiveFilterObj());
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::GETACTIVEFILTERVARERROR);
        }
    }
}
/** @} */ // end of group
?>
