<?php
/**
 * \ingroup updateAdminUser
 * \defgroup getPermissions getPermissions
 * @{
*/
class Permissions {
    private $permissions, $parent;
    public $effective, $type;
    private $domainPermissionList = array(
        "managedomainconfig" => 1,
        "managedomainfilters" => 1,
        "backupdomain" => 1,
        "restoredomain" => 1,
        "deactivatedomain" => 1,
        "managedomainadminlimits" => 1,
        "managedomainservices" => 1,
        "managecatchall" => 1,
        "managegroupware" => 1,
        "manageldapsync" => 1,
        "managedomainaliases" => 1,
        "managedomainstorage" => 1,
        "manageaccountservices" => 1,
        "manageautomaticmigration" => 1,
        "managefoldersquotas" => 1,
        "managepasswordpolicy" => 1,
        "managewebmaillimits" => 1,
        "managefilteredemail" => 1,
        "managesendreceiverestrictions" => 1,
        "managerpoprestrictions" => 1,
        "managetemporaryaddresses" => 1,
        "manageaccountrecovery" => 1,
        "managepersonalorganizer" => 1,
        "managesharing" => 1,
        "manageoutlookconnector" => 1,
        "manageactivesync" => 1,
        "managekasperskyantivirus" => 1,
        "managekasperskyantispam" => 1,
        "manageimageanalyzer" => 1,
        "manageaccounts" => 1,
        "createaccounts" => 1,
        "removeaccounts" => 1,
        "manageaccountsnaming" => 1,
        "changeaccountspassword" => 1,
        "changeaccountsclass" => 1,
        "manageaccountscontactinformation" => 1,
        "manageaccountswebmailoptions" => 1,
        "managegroups" => 1,
        "creategroups" => 1,
        "removegroups" => 1,
        "managegroupsnaming" => 1,
        "managegroupsmembers" => 1,
        "managemaillists" => 1,
        "createmaillists" => 1,
        "removemaillists" => 1,
        "managemaillistsnaming" => 1,
        "changemaillistspassword" => 1,
        "managemaillistsmembers" => 1,
        "managemaillistssubscription" => 1,
        "managemaillistsposting" => 1,
        "managemaillistsmessageheaders" => 1,
        "managemailliststemplates" => 1,
        "managemaillistswebmailoptions" => 1,
        "managemaillistsservices" => 1,
        "managemaillistsfoldersquotas" => 1,
        "managemaillistswebmaillimits" => 1,
        "managemaillistssendreceiverestrictions" => 1,
        "manageaccountclasses" => 1,
        "createaccountclasses" => 1,
        "removeaccountclasses" => 1,
        "renameaccountclasses" => 1,
        "managefolderrecipients" => 1,
        "managepublicfolder" => 1,
        "createpublicfolder" => 1,
        "removepublicfolder" => 1,
        "renamepublicfolder" => 1,
        "managepublicfoldersquotas" => 1
    );
    private $serverPermissionList = array(
        "manageserverconfig" => 1,
        "manageserverfilters" => 1,
        "managecluster" => 1,
        "manageprocessing" => 1,
        "managelog" => 1,
        "managednr" => 1,
        "managesmtpin" => 1,
        "managesmtpout" => 1,
        "managepop3" => 1,
        "manageimap" => 1,
        "managewebmail" => 1,
        "managerpop" => 1,
        "managepop3proxy" => 1,
        "manageimapproxy" => 1,
        "managewebmailproxy" => 1,
        "managecli" => 1,
        "managewebadmin" => 1,
        "manageftpbackup" => 1,
        "managereporting" => 1,
        "manageauthentication" => 1,
        "activateanydomain" => 1,
        "manageconfigonanydomain" => 1,
        "managefiltersonanydomain" => 1,
        "backupanydomain" => 1,
        "restoreanydomain" => 1,
        "deactivateanydomain" => 1,
        "manageadminlimitsonanydomain" => 1,
        "manageservicesonanydomain" => 1,
        "managecatchallonanydomain" => 1,
        "managegroupwareonanydomain" => 1,
        "manageldapsynconanydomain" => 1,
        "managedomainaliasesonanydomain" => 1,
        "managedomainstorageonanydomain" => 1,
        "manageaccountservicesonanydomain" => 1,
        "manageautomaticmigrationonanydomain" => 1,
        "managefoldersquotasonanydomain" => 1,
        "managepasswordpolicyonanydomain" => 1,
        "managewebmaillimitsonanydomain" => 1,
        "managefilteredemailonanydomain" => 1,
        "managesendreceiverestrictionsonanydomain" => 1,
        "managerpoprestrictionsonanydomain" => 1,
        "managetemporaryaddressesonanydomain" => 1,
        "manageaccountrecoveryonanydomain" => 1,
        "managepersonalorganizeronanydomain" => 1,
        "managesharingonanydomain" => 1,
        "manageoutlookconnectoronanydomain" => 1,
        "manageactivesynconanydomain" => 1,
        "managekasperskyantivirusonanydomain" => 1,
        "managekasperskyantispamonanydomain" => 1,
        "manageimageanalyzeronanydomain" => 1,
        "manageaccountsonanydomain" => 1,
        "createaccountsonanydomain" => 1,
        "removeaccountsonanydomain" => 1,
        "manageaccountsnamingonanydomain" => 1,
        "changeaccountspasswordonanydomain" => 1,
        "changeaccountsclassonanydomain" => 1,
        "manageaccountscontactinformationonanydomain" => 1,
        "manageaccountswebmailoptionsonanydomain" => 1,
        "managegroupsonanydomain" => 1,
        "creategroupsonanydomain" => 1,
        "removegroupsonanydomain" => 1,
        "managegroupsnamingonanydomain" => 1,
        "managegroupsmembersonanydomain" => 1,
        "managemaillistsonanydomain" => 1,
        "createmaillistsonanydomain" => 1,
        "removemaillistsonanydomain" => 1,
        "managemaillistsnamingonanydomain" => 1,
        "changemaillistspasswordonanydomain" => 1,
        "managemaillistsmemberonanydomain" => 1,
        "managemaillistssubscriptiononanydomain" => 1,
        "managemaillistspostingonanydomain" => 1,
        "managemaillistsmessageheadersonanydomain" => 1,
        "managemailliststemplatesonanydomain" => 1,
        "managemaillistswebmailoptionsonanydomain" => 1,
        "managemaillistsservicesonanydomain" => 1,
        "managemaillistsfoldersquotasonanydomain" => 1,
        "managemaillistswebmaillimitsonanydomain" => 1,
        "managemaillistssendreceiverestrictionsonanydomain" => 1,
        "manageaccountclassesonanydomain" => 1,
        "createaccountclassesonanydomain" => 1,
        "removeaccountclassesonanydomain" => 1,
        "renameaccountclassesonanydomain" => 1,
        "managefolderrecipientsonanydomain" => 1,
        "managepublicfolderonanydomain" => 1,
        "createpublicfolderonanydomain" => 1,
        "removepublicfolderonanydomain" => 1,
        "renamepublicfolderonanydomain" => 1,
        "managepublicfoldersquotasonanydomain" => 1,
        "manageadminacl" => 1
    );
    public function __construct($permissionsObj, $parent) {
        $this->permissions = $permissionsObj;
        $this->parent = $parent;
        $this->effective = false;
        $this->type = "server";
    }
    public function __destruct() {
    }
    public function getSessionObj() {
        if ($this->parent == null) return $this->session;
        return $this->parent->getSessionObj();
    }
    public function getPermissionsObj() {
        return $this->permissions;
    }
    /**
     * saves permissions
     * return bool
     */
    public function save() {
        return $this->parent->savePermissions($this->getPermissionsObj());
    }
    /**
     * denies permission for the selected user or group
     * @note is not available for effective permissions
     * return bool
     * @param $permission string the permission name
     */
    public function denyPermission($permission) {
        if (!$this->getPermissionsObj()) return false;
        if ($this->effective) return false;
        if ($this->type == "domain") {
            if (array_key_exists(strtolower($permission) , $this->domainPermissionList)) {
                $resp = deny_permission($this->getPermissionsObj() , $permission);
            } else {
                return false;
            }
        } elseif ($this->type == "server") {
            if (array_key_exists(strtolower($permission) , $this->serverPermissionList)) {
                $resp = deny_permission($this->getPermissionsObj() , $permission);
            } else {
                return false;
            }
        } else {
            return false;
        }
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SETDENYPERMISSION);
    }
    /**
     * revokes permission for the selected user or group
     * @note is not available for effective permissions
     * return bool
     * @param $permission string the permission name
     */
    public function revokePermission($permission) {
        if (!$this->getPermissionsObj()) return false;
        if ($this->effective) return false;
        if ($this->type == "domain") {
            if (array_key_exists(strtolower($permission) , $this->domainPermissionList)) {
                $resp = revoke_permission($this->getPermissionsObj() , $permission);
            } else {
                return false;
            }
        } elseif ($this->type == "server") {
            if (array_key_exists(strtolower($permission) , $this->serverPermissionList)) {
                $resp = revoke_permission($this->getPermissionsObj() , $permission);
            } else {
                return false;
            }
        } else {
            return false;
        }
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SETREVOKEPERMISSION);
    }
    /**
     * grants a permission for the selected user or group
     * @note is not available for effective permissions
     * return bool
     * @param $permission string the permission name
     */
    public function grantPermission($permission) {
        if (!$this->getPermissionsObj()) return false;
        if ($this->effective) return false;
        if ($this->type == "domain") {
            if (array_key_exists(strtolower($permission) , $this->domainPermissionList)) {
                $resp = grant_permission($this->getPermissionsObj() , $permission);
            } else {
                return false;
            }
        } elseif ($this->type == "server") {
            if (array_key_exists(strtolower($permission) , $this->serverPermissionList)) {
                $resp = grant_permission($this->getPermissionsObj() , $permission);
            } else {
                return false;
            }
        } else {
            return false;
        }
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SETGRANTPERMISSION);
    }
    /**
     * shows permissions for the selected user/group
     * @return array
     */
    public function showPermissions() {
        if (!$this->getPermissionsObj()) return false;
        $permissions = array();
        if ($this->type == "domain") {
            $permList = $this->domainPermissionList;
        } elseif ($this->type == "server") {
            $permList = $this->serverPermissionList;
        } else {
            return false;
        }
        foreach($permList as $permission => $tmp) {
            $permissions[$permission]['deny'] = permission_is_denied($this->getPermissionsObj() , $permission);
            $permissions[$permission]['grant'] = permission_is_granted($this->getPermissionsObj() , $permission);
            $permissions[$permission]['revoke'] = permission_is_uninitted($this->getPermissionsObj() , $permission);
        }
        return $permissions;
    }
}
/** @} */ // end of group
?>
