<?php
/**
 * \ingroup configFilters
 * \defgroup listSocketFilters listSocketFilters
 * @{
 * This is the object containing the scriptfilters data for the selected filter
 * @note
 */
class ScriptFilters {
    private $scriptfilter, $parent;
    public function __construct($scriptfilterObj, $parentObj) {
        $this->scriptfilter = $scriptfilterObj;
        $this->parent = $parentObj;
    }
    public function __destruct() {
        //filters_d($this->getScriptFilterObj());
        
    }
    public function getSessionObj() {
        if ($this->parent == null) return $this->session;
        return $this->parent->getSessionObj();
    }
    public function getScriptFilterObj() {
        return $this->scriptfilter;
    }
    /**
     * Uploads a SIEVE filter to the Axigen server with the name pointed by the selected scriptfilter file name
     * @return bool
     * @param $filterData string the filter data that you want to upload
     */
    public function uploadFilter($filterData) {
        if (!$this) return false;
        $resp = filters_upload_script_filter($this->getScriptFilterObj() , $this->getSessionObj() , $filterData);
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::UPLOADSCRIPTFILTER);
    }
    /**
     * this method must be called if one of the members has been changed
     * @return bool
     */
    public function save() {
        if (!$this) return false;
        $resp = filters_save($this->parent->getFiltersObj() , $this->getSessionObj());
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SAVESCRIPTFILTERDATA);
    }
    /**
Set member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>name</td>
<td>sets the name of the filter</td>
<tr><td>type</td>
<td>sets the type of the script filter</td>
<tr><td>file</td>
<td>sets the path to the file where the script is located</td>
</table>
     */
    public function __set($varName, $varValue) {
        if (!$this) return false;
        switch ($varName) {
            case "name":
                $resp = script_filter_name_set($this->getScriptFilterObj() , $varValue);
            break;
            case "type":
                $resp = script_filter_type_set($this->getScriptFilterObj() , $varValue);
            break;
            case "file":
                $resp = script_filter_file_set($this->getScriptFilterObj() , $varValue);
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::SETSCRIPTFILTERVARERROR);
                return;
        }
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SETSCRIPTFILTERVARERROR);
    }
    /**
Get member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>name</td>
<td>sets the name of the filter</td>
<tr><td>type</td>
<td>sets the type of the script filter</td>
<tr><td>file</td>
<td>sets the path to the file where the script is located</td>
</table>
     */
    public function __get($varName) {
        if (!$this) return false;
        switch ($varName) {
            case "name":
                return script_filter_name_get($this->getScriptFilterObj());
            break;
            case "type":
                return script_filter_type_get($this->getScriptFilterObj());
            break;
            case "file":
                return script_filter_file_get($this->getScriptFilterObj());
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::GETSCRIPTFILTERVARERROR);
        }
    }
}
/** @} */ // end of group
?>
