<?php
/**
 * \ingroup configServer
 * \defgroup configSmtpIn configSmtpIn
 * @{
*/
class SmtpIn {
    private $smtpInObj, $parent, $listener, $accesscontrol;
    public function __construct($smtpInObj, $parent) {
        $this->smtpInObj = $smtpInObj;
        $this->parent = $parent;
    }
    public function __destruct() {
        smtp_in_destroy($this->getSmtpInObj());
    }
    public function getSessionObj() {
        if ($this->parent == null) return $this->session;
        return $this->parent->getSessionObj();
    }
    public function getSmtpInObj() {
        return $this->smtpInObj;
    }
    /**
Get member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>maxConnThreads</td>
<td>the maximum number of threads involved in I/O for the SMTP Incoming service</td>
<tr><td>minConnThreads</td>
<td>the minimum number of threads involved in I/O for the SMTP Incoming service</td>
<tr><td>maxErrors</td>
<td>the maximum number of protocol errors after which the connection is terminated</td>
<tr><td>maxAuthErrors</td>
<td>the maximum number of authentication errors after which the connection is terminated</td>
<tr><td>maxReceivedHeaders</td>
<td>the maximum number of headers that an email received by Axigen can have</td>
<tr><td>enableSmtpRouting</td>
<td>the enabled/disabled status for SMTP Routing</td>
<tr><td>mappingDataUsermapName</td>
<td>the mapping usermap name for the proxy</td>
<tr><td>mappingDataMappingHost</td>
<td>the mapping data host for the proxy</td>
<tr><td>mappingDataMappingPort</td>
<td>the mapping data port for the proxy</td>
<tr><td>userdbConnectorType</td>
<td>the type of the userdb connector</td>
<tr><td>userdbConnectorName</td>
<td>the name of the userdb connector</td>
<tr><td>logLevel</td>
<td>the log level for the SMTP Incoming service</td>
<tr><td>logHost</td>
<td>the address of the host that offers log services</td>
<tr><td>logType</td>
<td>the log type for the SMTP Incoming service</td>
</table>
     */
    public function __get($name) {
        switch ($name) {
            case 'maxConnThreads':
                return $this->getMaxConnThreads();
            break;
            case 'minConnThreads':
                return $this->getMinConnThreads();
            break;
            case 'maxErrors':
                return $this->getMaxErrors();
            break;
            case 'maxAuthErrors':
                return $this->getMaxAuthErrors();
            break;
            case 'maxReceivedHeaders':
                return $this->getMaxReceivedHeaders();
            break;
            case 'enableSmtpRouting':
                return $this->getEnableSmtpRouting();
            break;
            case 'mappingDataUsermapName':
                return $this->getMappingDataUsermapName();
            break;
            case 'mappingDataMappingHost':
                return $this->getMappingDataMappingHost();
            break;
            case 'mappingDataMappingPort':
                return $this->getMappingDataMappingPort();
            break;
            case 'userdbConnectorType':
                return $this->getUserdbConnectorType();
            break;
            case 'userdbConnectorName':
                return $this->getUserdbConnectorName();
            break;
            case 'logLevel':
                return $this->getLogLevel();
            break;
            case 'logHost':
                return $this->getLogHost();
            break;
            case 'logType':
                return $this->getLogType();
            break;
            default:;
            break;
        }
    }
    /**
Set member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>maxConnThreads</td>
<td>the maximum number of threads involved in I/O for the SMTP Incoming service</td>
<tr><td>minConnThreads</td>
<td>the minimum number of threads involved in I/O for the SMTP Incoming service</td>
<tr><td>maxErrors</td>
<td>the maximum number of protocol errors after which the connection is terminated</td>
<tr><td>maxAuthErrors</td>
<td>the maximum number of authentication errors after which the connection is terminated</td>
<tr><td>maxReceivedHeaders</td>
<td>the maximum number of headers that an email received by Axigen can have</td>
<tr><td>enableSmtpRouting</td>
<td>the enabled/disabled status for SMTP Routing</td>
<tr><td>mappingDataUsermapName</td>
<td>the mapping usermap name for the proxy</td>
<tr><td>mappingDataMappingHost</td>
<td>the mapping data host for the proxy</td>
<tr><td>mappingDataMappingPort</td>
<td>the mapping data port for the proxy</td>
<tr><td>userdbConnectorType</td>
<td>the type of the userdb connector</td>
<tr><td>userdbConnectorName</td>
<td>the name of the userdb connector</td>
<tr><td>logLevel</td>
<td>the log level for the SMTP Incoming service</td>
<tr><td>logHost</td>
<td>the address of the host that offers log services</td>
<tr><td>logType</td>
<td>the log type for the SMTP Incoming service</td>
</table>
     */
    public function __set($name, $value) {
        switch ($name) {
            case 'maxConnThreads':
                return $this->setMaxConnThreads($value);
            break;
            case 'minConnThreads':
                return $this->setMinConnThreads($value);
            break;
            case 'maxErrors':
                return $this->setMaxErrors($value);
            break;
            case 'maxAuthErrors':
                return $this->setMaxAuthErrors($value);
            break;
            case 'maxReceivedHeaders':
                return $this->setMaxReceivedHeaders($value);
            break;
            case 'enableSmtpRouting':
                return $this->setEnableSmtpRouting($value);
            break;
            case 'mappingDataUsermapName':
                return $this->setMappingDataUsermapName($value);
            break;
            case 'mappingDataMappingHost':
                return $this->setMappingDataMappingHost($value);
            break;
            case 'mappingDataMappingPort':
                return $this->setMappingDataMappingPort($value);
            break;
            case 'userdbConnectorType':
                return $this->setUserdbConnectorType($value);
            break;
            case 'userdbConnectorName':
                return $this->setUserdbConnectorName($value);
            break;
            case 'logLevel':
                return $this->setLogLevel($value);
            break;
            case 'logHost':
                return $this->setLogHost($value);
            break;
            case 'logType':
                return $this->setLogType($value);
            break;
            default:;
            break;
        }
    }
    /*******************************************************************************
    * Getters
    */
    /**
     * @ignore
     * This function returns the maximum number of threads involved in I/O for this service
     *
     * @return int
     */
    public function getMaxConnThreads() {
        return smtp_in_max_connection_threads_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the minimum number of threads involved in I/O for this service
     *
     * @return int
     */
    public function getMinConnThreads() {
        return smtp_in_min_connection_threads_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the maximum number of protocol errors after which the connection is terminated
     *
     * @return int
     */
    public function getMaxErrors() {
        return smtp_in_max_errors_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the maximum number of authentication errors after which the connection is terminated
     *
     * @return int
     */
    public function getMaxAuthErrors() {
        return smtp_in_max_auth_errors_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the maximum number of headers an email received by Axigen can have
     *
     * @return int
     */
    public function getMaxReceivedHeaders() {
        return smtp_in_max_received_headers_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns 1 if SMTP routing is enabled and 0 if not
     * Smtp routing is used in Axigen clustering
     *
     * @return int
     */
    public function getEnableSmtpRouting() {
        return smtp_in_enable_smtp_routing_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the mapping data usermap name
     *
     * @return string
     */
    public function getMappingDataUsermapName() {
        $mappingData = smtp_in_get_mapping_data($this->getSmtpInObj());
        if (Debug::checkError($mappingData, '_p_mapping_data', Debug::INFOERROR, Message::SMTPINGETMAPPINGDATA)) {
            return mapping_data_usermap_name_get($mappingData);
        }
    }
    /**
     * @ignore
     * This function returns the mapping data host
     *
     * @return string
     */
    public function getMappingDataMappingHost() {
        $mappingData = smtp_in_get_mapping_data($this->getSmtpInObj());
        if (Debug::checkError($mappingData, '_p_mapping_data', Debug::INFOERROR, Message::SMTPINGETMAPPINGDATA)) {
            return mapping_data_mapping_host_get($mappingData);
        }
    }
    /**
     * @ignore
     * This function returns the mapping data port
     *
     * @return string
     */
    public function getMappingDataMappingPort() {
        $mappingData = smtp_in_get_mapping_data($this->getSmtpInObj());
        if (Debug::checkError($mappingData, '_p_mapping_data', Debug::INFOERROR, Message::SMTPINGETMAPPINGDATA)) {
            return mapping_data_mapping_port_get($mappingData);
        }
    }
    /**
     * @ignore
     * This function returns the type of the userdb connector.
     * Returned values are: "local", "ldap" or "ldapBind"
     *
     * @return string
     */
    public function getUserdbConnectorType() {
        return smtp_in_userdb_connector_type_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the name of the userdb connector
     *
     * @return string
     */
    public function getUserdbConnectorName() {
        return smtp_in_userdb_connector_name_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the log level for this service
     *
     * @return int
     */
    public function getLogLevel() {
        return smtp_in_log_level_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the host which handles the logging (if the log type is not local)
     *
     * @return string
     */
    public function getLogHost() {
        return smtp_in_log_host_get($this->getSmtpInObj());
    }
    /**
     * @ignore
     * This function returns the log for this service.
     *
     * @return string Expected values are: "internal", "system" or "remote"
     */
    public function getLogType() {
        return smtp_in_log_type_get($this->getSmtpInObj());
    }
    /*******************************************************************************
    * Setters
    */
    /**
     * @ignore
     * This function sets the maximum number of threads involved in I/O for this service
     * @return bool
     *
     * @param $value int maximum number of connection threads
     */
    public function setMaxConnThreads($value) {
        $set = smtp_in_max_connection_threads_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETMAXCONNTHREADS);
    }
    /**
     * @ignore
     * This function sets the minimum number of threads involved in I/O for this service
     * @return bool
     *
     * @param $value int minimum number of connection threads
     */
    public function setMinConnThreads($value) {
        $set = smtp_in_min_connection_threads_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETMINCONNTHREADS);
    }
    /**
     * @ignore
     * This function sets the maximum number of protocol errors after which the connection is terminated.
     * @return bool
     *
     * @param $value int maximum number of errors
     */
    public function setMaxErrors($value) {
        $set = smtp_in_max_errors_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETMAXERRORS);
    }
    /**
     * @ignore
     * This function sets the maximum number of authentication errors after which the connection is terminated
     * @return bool
     *
     * @param $value int maximum number of authentication errors
     */
    public function setMaxAuthErrors($value) {
        $set = smtp_in_max_auth_errors_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETAUTHERRORS);
    }
    /**
     * @ignore
     * This function sets the maximum number of headers an email can have
     * @return bool
     *
     * @param $value int maximum number of headers an email can have
     */
    public function setMaxReceivedHeaders($value) {
        $set = smtp_in_max_received_headers_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETMAXRECEIVEDHEADERS);
    }
    /**
     * @ignore
     * This function enables/disables Smtp Routing
     * @return bool
     *
     * @param $value int If the 'value' parameter is 1 this function enables Smtp Routing, else it disables it
     */
    public function setEnableSmtpRouting($value) {
        $set = smtp_in_enable_smtp_routing_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETENABLESMTPROUTING);
    }
    /**
     * @ignore
     * This function sets the mapping usermap name
     * @return bool
     *
     * @param $value string the mapping data name
     */
    public function setMappingDataUsermapName($value) {
        $mappingData = smtp_in_get_mapping_data($this->getSmtpInObj());
        if (Debug::checkError($mappingData, '_p_mapping_data', Debug::INFOERROR, Message::SMTPINGETMAPPINGDATA)) {
            $set = mapping_data_usermap_name_set($mappingData, $value);
            Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETMAPPINGDATANAME);
            $save = mapping_data_save($mappingData, $this->getSessionObj());
            return Debug::checkError($save, 0, Debug::INFOERROR, Message::SMTPINSETMAPPINGDATANAME);
        }
    }
    /**
     * @ignore
     * This function sets the mapping host
     * @return bool
     *
     * @param $value string the mapping host
     */
    public function setMappingDataMappingHost($value) {
        $mappingData = smtp_in_get_mapping_data($this->getSmtpInObj());
        if (Debug::checkError($mappingData, '_p_mapping_data', Debug::INFOERROR, Message::SMTPINGETMAPPINGDATA)) {
            $set = mapping_data_mapping_host_set($mappingData, $value);
            Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETMAPPINGDATAHOST);
            $save = mapping_data_save($mappingData, $this->getSessionObj());
            return Debug::checkError($save, 0, Debug::INFOERROR, Message::SMTPINSETMAPPINGDATAHOST);
        }
    }
    /**
     * @ignore
     * This function sets the mapping port
     * @return bool
     *
     * @param $value int the mapping port
     */
    public function setMappingDataMappingPort($value) {
        $mappingData = smtp_in_get_mapping_data($this->getSmtpInObj());
        if (Debug::checkError($mappingData, '_p_mapping_data', Debug::INFOERROR, Message::SMTPINGETMAPPINGDATA)) {
            $set = mapping_data_mapping_port_set($mappingData, $value);
            Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETMAPPINGDATAPORT);
            $save = mapping_data_save($mappingData, $this->getSessionObj());
            return Debug::checkError($save, 0, Debug::INFOERROR, Message::SMTPINSETMAPPINGDATAPORT);
        }
    }
    /**
     * @ignore
     * This function sets the type of the userdb connector
     * @return bool
     *
     * @param $value string Valid values for the 'value' parameter are: "local", "ldap" or "ldapBind"
     */
    public function setUserdbConnectorType($value) {
        $set = smtp_in_userdb_connector_type_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETUSERDBCONTYPE);
    }
    /**
     * @ignore
     * This function sets the name of the userdb connector's name
     * @return bool
     *
     * @param $value string the name of the userdb connector's name
     */
    public function setUserdbConnectorName($value) {
        $set = smtp_in_userdb_connector_name_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETUSERDBCONNAME);
    }
    /**
     * @ignore
     * This function sets the log level for this service
     * @return bool
     *
     * @param $value int log level
     */
    public function setLogLevel($value) {
        $set = smtp_in_log_level_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETLOGLEVEL);
    }
    /**
     * @ignore
     * This function sets the address of the host that offers log services for Axigen
     * @return bool
     *
     * @param $value string log host
     */
    public function setLogHost($value) {
        $set = smtp_in_log_host_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETLOGHOST);
    }
    /**
     * @ignore
     * This function sets the log type for this service
     * @return bool
     *
     * @param $value string Valid values for the 'value' parameter are:
     * "internal"(used at logging in a local file),
     * "system"(used at logging in system log) or
     * "remote"(used at logging on a dedicated logging machine)
     * @paramtype string
     */
    public function setLogType($value) {
        $set = smtp_in_log_type_set($this->getSmtpInObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SMTPINSETLOGTYPE);
    }
    /**
     * @private
     * This function saves the SMTP Incoming configuration back to Axigen
     *
     * @return bool
     */
    public function save() {
        $save = smtp_in_save($this->getSmtpInObj() , $this->getSessionObj());
        return Debug::checkError($save, 0, Debug::INFOERROR, Message::SMTPINSAVE);
    }
    /**
     * @private
     * This function resets the changes made but not yet saved
     *
     * @return bool
     */
    public function reset() {
        $reset = smtp_in_reset($this->getSmtpInObj() , $this->getSessionObj());
        return Debug::checkError($reset, 0, Debug::INFOERROR, Message::SMTPINRESET);
    }
    /**
     * This function starts the SMTP Incoming service
     *
     * @return bool
     */
    public function start() {
        return $this->parent->startService("smtpin");
    }
    /**
     * This function stops the SMTP Incoming service
     *
     * @return bool
     */
    public function stop() {
        return $this->parent->stopService("smtpin");
    }
    /**
     * This function adds a listener to this service
     * @return bool
     * @param $address string the listener address (ex: 127.0.0.1:25)
     */
    public function addListener($address) {
        $listeners = smtp_in_listeners_get($this->getSmtpInObj() , $this->getSessionObj());
        if (!Debug::checkError($listeners, "_p_listeners", Debug::INFOERROR, Message::SMTPINGETLISTENERS)) return false;
        $listenerObj = listeners_add($listeners, $this->getSessionObj() , $address);
        if (!Debug::checkError($listenerObj, "_p_listener", Debug::INFOERROR, Message::SMTPINADDLISTENER)) return false;
        listeners_destroy($listeners);
        return true;
    }
    /**
     * This function removes a listener from this service
     * @return bool
     * @param $address string the listener address (ex: 127.0.0.1:25)
     */
    public function removeListener($address) {
        $listeners = smtp_in_listeners_get($this->getSmtpInObj() , $this->getSessionObj());
        if (!Debug::checkError($listeners, "_p_listeners", Debug::INFOERROR, Message::SMTPINGETLISTENERS)) return false;
        $resp = listeners_remove_by_address($listeners, $this->getSessionObj() , $address);
        listeners_destroy($listeners);
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SMTPINREMOVELISTENER);
    }
    /**
     * This function updates a listener of this service
     * @return object Listener
     * @param $address string the listener address (ex: 127.0.0.1:25)
     */
    public function updateListener($address) {
        if (!is_object($this->listener[$address])) {
            $listeners = smtp_in_listeners_get($this->getSmtpInObj() , $this->getSessionObj());
            if (!Debug::checkError($listeners, "_p_listeners", Debug::FATALERROR, Message::SMTPINGETLISTENERS)) return false;
            $listenerObj = listeners_get_by_address($listeners, $address);
            if (!Debug::checkError($listenerObj, "_p_listener", Debug::FATALERROR, Message::SMTPINUPDATELISTENER)) return false;
            $this->listener[$address] = new Listener($listenerObj, $this);
        }
        return $this->listener[$address];
    }
    /**
     * This function lists the listeners for this service
     * @return array
     */
    public function listListeners() {
        $listeners = array();
        $listenersObj = smtp_in_listeners_get($this->getSmtpInObj() , $this->getSessionObj());
        if (!Debug::checkError($listenersObj, "_p_listeners", Debug::INFOERROR, Message::SMTPINGETLISTENERS)) return false;
        $listenersIterObj = listener_iterator_begin($listenersObj);
        if (!Debug::checkError($listenersIterObj, "_p_listener_iterator", Debug::INFOERROR, Message::SMTPINGETLISTENERS)) return false;
        while (listener_iterator_has_value($listenersIterObj)) {
            $listenerObj = listener_iterator_value($listenersIterObj);
            unset($tmp);
            if (listener_enable_get($listenerObj) == 1) $tmp['enabled'] = true;
            else $tmp['enabled'] = false;
            $tmp['address'] = listener_address_get($listenerObj);
            array_push($listeners, $tmp);
            listener_iterator_next($listenersIterObj);
        }
        listener_iterator_destroy($listenersIterObj);
        listeners_destroy($listenersObj);
        return $listeners;
    }
    /**
     * This function returns an access control object for this service
     * @return object AccessControl
     */
    public function configAccessControl() {
        if (!is_object($this->accesscontrol)) {
            $accesscontrolObj = smtp_incoming_get_access_control($this->getSmtpInObj() , $this->getSessionObj());
            if (!Debug::checkError($accesscontrolObj, "_p_access_control", Debug::FATALERROR, Message::SMTPINACCESSCONTROL)) return false;
            $this->accesscontrol = new AccessControl($accesscontrolObj, $this);
        }
        return $this->accesscontrol;
    }
}
/** @} */ // end of group
?>
