<?php
/** New Doc 0 */
/** Last Update 1/Apr/2009  17:32 */
class UdpListener {
    private $udplistener, $parent;
    public function __construct($udpListenerObj, $parent) {
        $this->udplistener = $udpListenerObj;
        $this->parent = $parent;
    }
    public function __destruct() {
        udplistener_destroy($this->getUdpListenerObj());
    }
    public function getSessionObj() {
        if ($this->parent == null) return $this->session;
        return $this->parent->getSessionObj();
    }
    public function getUdpListenerObj() {
        return $this->udplistener;
    }
    /*
     * @members set
     * @member address
     * @desc the address of the UDP listener
     * @member enable
     * @desc the enabled/disabled status of the UDP listener
     */
    public function __set($varName, $varValue) {
        if (!$this) return false;
        switch ($varName) {
            case "address":
                $resp = udplistener_address_set($this->getUdpListenerObj() , $varValue);
            break;
            case "enable":
                switch (strtolower($varValue)) {
                    case 1:
                        $val = 1;
                    break;
                    case "yes":
                        $val = 1;
                    break;
                    default:
                        $val = 0;
                }
                $resp = udplistener_enable_set($this->getUdpListenerObj() , $val);
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::SETUDPLISTENERVARERROR);
                return;
        }
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SETUDPLISTENERVARERROR);
    }
    /*
     * @members get
     * @member address
     * @desc the address of the UDP listener
     * @member enable
     * @desc the enabled/disabled status of the UDP listener
     */
    public function __get($varName) {
        if (!$this) return false;
        switch ($varName) {
            case "address":
                return udplistener_address_get($this->getUdpListenerObj());
            break;
            case "enable":
                return udplistener_enable_get($this->getUdpListenerObj());
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::GETUDPLISTENERVARERROR);
        }
    }
    /*
     * @method save
     * @desc This function saves the UdpListener configuration back to Axigen
     * @return bool
     */
    public function save() {
        if (!$this) return false;
        $resp = udplistener_save($this->getUdpListenerObj() , $this->getSessionObj());
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SAVELISTENERDATA);
    }
}
?>
