<?php
/**
 * \ingroup configServer
 * \defgroup updateUsermap updateUsermap
 * @{
*/
class Usermap {
    private $usermap, $parent;
    public function __construct($usermapObj, $parentObj) {
        $this->usermap = $usermapObj;
        $this->parent = $parentObj;
    }
    public function getSessionObj() {
        if ($this->parent == null) return $this->session;
        return $this->parent->getSessionObj();
    }
    public function getUsermapObj() {
        return $this->usermap;
    }
    /**
     * this method must be called if one of the members has been changed
     * @return bool
     */
    public function save() {
        return $this->parent->save();
    }
    /**
Get member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>name</td>
<td>the usermap name</td>
<tr><td>type</td>
<td>the usermap type</td>
<tr><td>userdbConnectorName</td>
<td>the name of the userdb connector</td>
<tr><td>userdbConnectorType</td>
<td>the userdb connector type (valid values for the 'userdb_connector_type' are: "local", "ldap" or "ldapBind")</td>
<tr><td>usermapLocalFile</td>
<td>the local file of the usermap (this is used when the user mapping information is local.)</td>
</table>
     */
    public function __get($name) {
        switch ($name) {
            case "name":
                return $this->getName();
            break;
            case "type":
                return $this->getType();
            break;
            case "userdbConnectorName":
                return $this->getUserdbConnectorName();
            break;
            case "userdbConnectorType":
                return $this->getUserdbConnectorType();
            break;
            case "usermapLocalFile":
                return $this->getUsermapLocalFile();
            break;
        }
    }
    /**
Set member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>name</td>
<td>the usermap name</td>
<tr><td>type</td>
<td>the usermap type</td>
<tr><td>userdbConnectorName</td>
<td>the name of the userdb connector</td>
<tr><td>userdbConnectorType</td>
<td>the userdb connector type (valid values for the 'userdb_connector_type' are: "local", "ldap" or "ldapBind")</td>
<tr><td>usermapLocalFile</td>
<td>the local file of the usermap (this is used when the user mapping information is local.)</td>
</table>
     */
    public function __set($name, $value) {
        switch ($name) {
            case "name":
                return $this->setName($value);
            break;
            case "type":
                return $this->setType($value);
            break;
            case "userdbConnectorName":
                return $this->setUserdbConnectorName($value);
            break;
            case "userdbConnectorType":
                return $this->setUserdbConnectorType($value);
            break;
            case "usermapLocalFile":
                return $this->setUsermapLocalFile($value);
            break;
        }
    }
    /*******************************************************************************
    * Getters
    */
    /**
     * @ignore
     */
    public function getName() {
        return usermap_name_get($this->getUsermapObj());
    }
    /**
     * @ignore
     */
    public function getType() {
        return usermap_type_get($this->getUsermapObj());
    }
    /**
     * @ignore
     */
    public function getUserdbConnectorName() {
        return usermap_userdb_connector_name_get($this->getUsermapObj());
    }
    /**
     * @ignore
     */
    public function getUserdbConnectorType() {
        return usermap_userdb_connector_type_get($this->getUsermapObj());
    }
    /**
     * @ignore
     */
    public function getUsermapLocalFile() {
        return usermap_localFile_get($this->getUsermapObj());
    }
    /*******************************************************************************
    * Setters
    */
    /**
     * @ignore
     */
    public function setName($value) {
        $set = usermap_name_set($this->getUsermapObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SETUSERMAPNAME);
    }
    /**
     * @ignore
     */
    public function setType($value) {
        $set = usermap_type_set($this->getUsermapObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SETUSERMAPTYPE);
    }
    /**
     * @ignore
     */
    public function setUserdbConnectorName($value) {
        $set = usermap_userdb_connector_name_set($this->getUsermapObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SETUSERMAPUSERDBCONNAME);
    }
    /**
     * @ignore
     */
    public function setUserdbConnectorType($value) {
        $set = usermap_userdb_connector_name_set($this->getUsermapObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SETUSERMAPUSERDBCONTYPE);
    }
    /**
     * @ignore
     */
    public function setUsermapLocalFile($value) {
        $set = usermap_userdb_connector_name_set($this->getUsermapObj() , $value);
        return Debug::checkError($set, 0, Debug::INFOERROR, Message::SETUSERMAPLOCALFILE);
    }
}
/** @} */ // end of group
?>
