<?php
/**
 * This object contains the WebmailAdvertising data.
 * \ingroup updateAccount
 * \defgroup configWebmailAdvertising configWebmailAdvertising
 * @{
 */
class WebmailAdvertising {
    private $webmailadvertising, $parent;
    public function __construct($webmailadvertisingObj, $parentObj) {
        $this->webmailadvertising = $webmailadvertisingObj;
        $this->parent = $parentObj;
    }
    public function __destruct() {
        webmailadvertising_destroy($this->getWebmailAdvertisingObj());
    }
    public function getSessionObj() {
        if ($this->parent == null) return $this->session;
        return $this->parent->getSessionObj();
    }
    public function getWebmailAdvertisingObj() {
        return $this->webmailadvertising;
    }
    /**
Set member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>enableTopBanner</td>
<td>enabled/disabled top Webmail banner</td>
<tr><td>enableRightBanner</td>
<td>enabled/disabled right Webmail banner</td>
<tr><td>enableBottomBanner</td>
<td>enabled/disabled bottom Webmail banner</td>
<tr><td>topBannerContent</td>
<td>the content of the top banner</td>
<tr><td>rightBannerContent</td>
<td>the content of the right banner </td>
<tr><td>bottomBannerContent</td>
<td>the content of the bottom banner</td>
</table>
     */
    public function __set($varName, $varValue) {
        if (!$this) return false;
        switch (strtolower($varName)) {
            case "enabletopbanner":
                $resp = webmailadvertising_enable_top_banner_set($this->getWebmailAdvertisingObj() , $varValue);
            break;
            case "enablerightbanner":
                $resp = webmailadvertising_enable_right_banner_set($this->getWebmailAdvertisingObj() , $varValue);
            break;
            case "enablebottombanner":
                $resp = webmailadvertising_enable_bottom_banner_set($this->getWebmailAdvertisingObj() , $varValue);
            break;
            case "topbannercontent":
                $resp = webmailadvertising_top_banner_content_set($this->getWebmailAdvertisingObj() , $varValue);
            break;
            case "rightbannercontent":
                $resp = webmailadvertising_right_banner_content_set($this->getWebmailAdvertisingObj() , $varValue);
            break;
            case "bottombannercontent":
                $resp = webmailadvertising_bottom_banner_content_set($this->getWebmailAdvertisingObj() , $varValue);
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::SETWEBMAILADVERTISINGERROR);
                return;
        }
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SETWEBMAILADVERTISINGERROR);
    }
    /**
Get member.
<table>
<tr><th>member</th><th>description</th>
<tr><td>enableTopBanner</td>
<td>enabled/disabled top Webmail banner</td>
<tr><td>enableRightBanner</td>
<td>enabled/disabled right Webmail banner</td>
<tr><td>enableBottomBanner</td>
<td>enabled/disabled bottom Webmail banner</td>
<tr><td>topBannerContent</td>
<td>the content of the top banner</td>
<tr><td>rightBannerContent</td>
<td>the content of the right banner </td>
<tr><td>bottomBannerContent</td>
<td>the content of the bottom banner</td>
</table>
     */
    public function __get($varName) {
        if (!$this) return false;
        switch (strtolower($varName)) {
            case "enabletopbanner":
                return webmailadvertising_enable_top_banner_get($this->getWebmailAdvertisingObj());
            break;
            case "enablerightbanner":
                return webmailadvertising_enable_right_banner_get($this->getWebmailAdvertisingObj());
            break;
            case "enablebottombanner":
                return webmailadvertising_enable_bottom_banner_get($this->getWebmailAdvertisingObj());
            break;
            case "topbannercontent":
                return webmailadvertising_top_banner_content_get($this->getWebmailAdvertisingObj());
            break;
            case "rightbannercontent":
                return webmailadvertising_right_banner_content_get($this->getWebmailAdvertisingObj());
            break;
            case "bottombannercontent":
                return webmailadvertising_bottom_banner_content_get($this->getWebmailAdvertisingObj());
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::GETWEBMAILADVERTISINGERROR);
                return;
        }
    }
    /**
     * Check if the variable is inherited
     * @return int (1 if the value is inherited, 0 if not, or -1 if this does not apply to the current quota object)
     * @param $varName string the variable
     */
    public function isInherited($varName) {
        if (!$this) return false;
        switch (strtolower($varName)) {
            case "enabletopbanner":
                $resp = webmailadvertising_enable_top_banner_is_inherited($this->getWebmailAdvertisingObj());
            break;
            case "enablerightbanner":
                $resp = webmailadvertising_enable_right_banner_is_inherited($this->getWebmailAdvertisingObj());
            break;
            case "enablebottombanner":
                $resp = webmailadvertising_enable_bottom_banner_is_inherited($this->getWebmailAdvertisingObj());
            break;
            case "topbannercontent":
                $resp = webmailadvertising_top_banner_content_is_inherited($this->getWebmailAdvertisingObj());
            break;
            case "rightbannercontent":
                $resp = webmailadvertising_right_banner_content_is_inherited($this->getWebmailAdvertisingObj());
            break;
            case "bottombannercontent":
                $resp = webmailadvertising_bottom_banner_content_is_inherited($this->getWebmailAdvertisingObj());
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::ISINHERITEDWEBMAILADVERTISINGVARERROR);
                return -1;
        }
        return $resp;
    }
    /**
     * sets the variable to inherit from the selected source
     * @return bool
     * @param $varName string the variable
     */
    public function inherit($varName) {
        if (!$this) return false;
        switch (strtolower($varName)) {
            case "enabletopbanner":
                $resp = webmailadvertising_enable_top_banner_inherit($this->getWebmailAdvertisingObj() , $this->getSessionObj());
            break;
            case "enablerightbanner":
                $resp = webmailadvertising_enable_right_banner_inherit($this->getWebmailAdvertisingObj() , $this->getSessionObj());
            break;
            case "enablebottombanner":
                $resp = webmailadvertising_enable_bottom_banner_inherit($this->getWebmailAdvertisingObj() , $this->getSessionObj());
            break;
            case "topbannercontent":
                $resp = webmailadvertising_top_banner_content_inherit($this->getWebmailAdvertisingObj() , $this->getSessionObj());
            break;
            case "rightbannercontent":
                $resp = webmailadvertising_right_banner_content_inherit($this->getWebmailAdvertisingObj() , $this->getSessionObj());
            break;
            case "bottombannercontent":
                $resp = webmailadvertising_bottom_banner_content_inherit($this->getWebmailAdvertisingObj() , $this->getSessionObj());
            break;
            default:
                Debug::checkError("0", "1", Debug::INFOERROR, Message::INHERITWEBMAILADVERTISINGVARERROR);
                return;
        }
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::INHERITWEBMAILADVERTISINGVARERROR);
    }
    /**
     * this method must be called if one of the members has been changed
     * @return bool
     */
    public function save() {
        if (!$this) return false;
        $resp = webmailadvertising_save($this->getWebmailAdvertisingObj() , $this->getSessionObj());
        return Debug::checkError($resp, 0, Debug::INFOERROR, Message::SAVEWEBMAILADVERTISINGDATAERROR);
    }
}
/** @} */ // end of group
?>
